import { DynamicModule, OnApplicationBootstrap, OnApplicationShutdown } from '@nestjs/common';
import { DiscoveryService, MetadataScanner, ModuleRef, Reflector } from '@nestjs/core';
import { WebSocketModuleOptions, WebSocketModuleAsyncOptions } from './websocket.interface';
export declare class WebSocketCoreModule implements OnApplicationBootstrap, OnApplicationShutdown {
    private readonly providerName;
    private readonly moduleRef;
    private readonly discoveryService;
    private readonly metadataScanner;
    private readonly reflector;
    constructor(providerName: string, moduleRef: ModuleRef, discoveryService: DiscoveryService, metadataScanner: MetadataScanner, reflector: Reflector);
    static forRoot(options: WebSocketModuleOptions): DynamicModule;
    static forRootAsync(options: WebSocketModuleAsyncOptions): DynamicModule;
    onApplicationBootstrap(): void;
    private listenToClientEvents;
    onApplicationShutdown(): void;
}
