"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var WebSocketCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebSocketCoreModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const WebSocket = require("ws");
const websocket_constants_1 = require("./websocket.constants");
const websocket_provider_1 = require("./websocket.provider");
let WebSocketCoreModule = WebSocketCoreModule_1 = class WebSocketCoreModule {
    constructor(providerName, moduleRef, discoveryService, metadataScanner, reflector) {
        this.providerName = providerName;
        this.moduleRef = moduleRef;
        this.discoveryService = discoveryService;
        this.metadataScanner = metadataScanner;
        this.reflector = reflector;
    }
    static forRoot(options) {
        const socketProvider = (0, websocket_provider_1.createWebSocketProvider)(options);
        return {
            module: WebSocketCoreModule_1,
            imports: [core_1.DiscoveryModule],
            providers: [socketProvider, (0, websocket_provider_1.createProviderName)()],
            exports: [socketProvider],
        };
    }
    static forRootAsync(options) {
        const socketProvider = (0, websocket_provider_1.createWebSocketAsyncProvider)();
        const asyncOptionsProvader = (0, websocket_provider_1.createAsyncOptionsProvider)(options);
        return {
            module: WebSocketCoreModule_1,
            imports: [core_1.DiscoveryModule, ...(options.imports || [])],
            providers: [
                asyncOptionsProvader,
                socketProvider,
                (0, websocket_provider_1.createProviderName)(),
                ...(options.providers || []),
            ],
            exports: [socketProvider],
        };
    }
    onApplicationBootstrap() {
        const providers = this.discoveryService.getProviders();
        const controllers = this.discoveryService.getControllers();
        this.listenToClientEvents(providers);
        this.listenToClientEvents(controllers);
    }
    listenToClientEvents(wrappers) {
        const ws = this.moduleRef.get(this.providerName);
        wrappers.forEach((wrapper) => {
            const { instance } = wrapper !== null && wrapper !== void 0 ? wrapper : {};
            if (wrapper.isDependencyTreeStatic() && instance) {
                const prototype = Object.getPrototypeOf(instance);
                this.metadataScanner.scanFromPrototype(instance, prototype, (methodKey) => {
                    const callback = instance[methodKey];
                    const metadata = this.reflector.get(websocket_constants_1.WEBSOCKET_EVENT_METADATA, callback);
                    if (metadata) {
                        ws.on(metadata.event, (...args) => {
                            callback.call(instance, ...args);
                        });
                    }
                });
            }
        });
    }
    onApplicationShutdown() {
        const ws = this.moduleRef.get(this.providerName);
        if (ws && ws.readyState === WebSocket.OPEN) {
            ws.removeAllListeners();
            ws.terminate();
        }
    }
};
WebSocketCoreModule = WebSocketCoreModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({}),
    __param(0, (0, common_1.Inject)(websocket_constants_1.WEBSOCKET_PROVIDER_NAME)),
    __metadata("design:paramtypes", [String, core_1.ModuleRef,
        core_1.DiscoveryService,
        core_1.MetadataScanner,
        core_1.Reflector])
], WebSocketCoreModule);
exports.WebSocketCoreModule = WebSocketCoreModule;
//# sourceMappingURL=websocket-core.module.js.map