"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnMessage = exports.OnError = exports.OnClose = exports.OnOpen = exports.EventListener = exports.InjectWebSocketProvider = void 0;
const common_1 = require("@nestjs/common");
const websocket_constants_1 = require("./websocket.constants");
const websocket_utils_1 = require("./websocket.utils");
const InjectWebSocketProvider = () => (0, common_1.Inject)((0, websocket_utils_1.getWebSocketToken)());
exports.InjectWebSocketProvider = InjectWebSocketProvider;
const EventListener = (event) => {
    return (0, common_1.SetMetadata)(websocket_constants_1.WEBSOCKET_EVENT_METADATA, { event });
};
exports.EventListener = EventListener;
const OnOpen = () => {
    return (0, common_1.SetMetadata)(websocket_constants_1.WEBSOCKET_EVENT_METADATA, { event: 'open' });
};
exports.OnOpen = OnOpen;
const OnClose = () => {
    return (0, common_1.SetMetadata)(websocket_constants_1.WEBSOCKET_EVENT_METADATA, { event: 'close' });
};
exports.OnClose = OnClose;
const OnError = () => {
    return (0, common_1.SetMetadata)(websocket_constants_1.WEBSOCKET_EVENT_METADATA, { event: 'error' });
};
exports.OnError = OnError;
const OnMessage = () => {
    return (0, common_1.SetMetadata)(websocket_constants_1.WEBSOCKET_EVENT_METADATA, { event: 'message' });
};
exports.OnMessage = OnMessage;
//# sourceMappingURL=websocket.decorators.js.map